Mantis Bug Tracker

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0006915opensim[REGION] Specific OpenSim Modulepublic2014-01-05 05:482014-07-29 13:42
Reporterorenh 
Assigned Todahlia 
PrioritynormalSeverityfeatureReproducibilityN/A
StatusclosedResolutionfixed 
PlatformOSOS Version
Product Versionmaster (dev code) 
Target Versionmaster (dev code)Fixed in Version 
Summary0006915: [PATCH] Materials: save materials as assets; fixed bugs; removed "Demo" status
DescriptionThis patch includes the following changes to the Materials module:

1. Save materials as assets (instead of as part of the prims, using dynamic attributes). This saves a lot of space and time if a material is reused often (e.g., bricks in a wall), because the material itself is stored only once, and each prim only stores a UUID reference to it. The implementation is also simpler than before because we don't need to convert between storage formats.

There's no known Asset Type for materials, so I assigned asset code -2 to them. Second Life uses only positive numbers for assets so this should be safe.

2. Fixed bugs that occurred when the user changed only individual faces, or removed the material from a prim.

3. Added permission checks so that only a user who is allowed to edit an object can change the object's materials.

4. Removed very frequent logging; removed the "Demo" attribute from the module name; and enabled the module by default.

TagsNo tags attached.
Git Revision or version number
Run Mode Grid (Multiple Regions per Sim)
Physics EngineODE
EnvironmentMono / Linux64, Mono / Windows
Mono Version3.2
Viewer
Attached Filespatch file icon 0001-Materials-support-the-viewer-removing-the-material-i.patch [^] (13,131 bytes) 2014-01-05 05:48 [Show Content]
patch file icon 0002-Renamed-MaterialsDemoModule-to-MaterialsModule.patch [^] (61,645 bytes) 2014-01-05 05:48 [Show Content]
patch file icon 0003-Materials-module-a-Store-materials-as-assets-b-Final.patch [^] (73,401 bytes) 2014-01-05 05:48 [Show Content]
patch file icon 0004-When-asked-to-change-the-Material-for-one-face-chang.patch [^] (3,130 bytes) 2014-01-05 05:48 [Show Content]
patch file icon 0005-Check-agent-permissions-before-modifying-an-object-s.patch [^] (5,494 bytes) 2014-01-05 05:48 [Show Content]

- Relationships
related to 0006824closedMata Hari script method to get/set materials textures 
related to 0006832closedMata Hari Materials Module - Applying bump or specular map to more than 1 face but not all causes all faces to take the new map 
related to 0006825closedMata Hari Enable MaterialsDemoModule by default in Opensim.ini.example 

-  Notes
(0024945)
dahlia (administrator)
2014-01-06 13:55

Thanks, Oren. I haven't had a chance to look these over yet but I will shortly. I would like to investigate a way to migrate existing materials to your new asset format before changing to using assets. I hope to do this ASAP. I may apply some of the other patches before that if they apply cleanly out of order.
(0024946)
Mata Hari (reporter)
2014-01-06 18:46

I know this is asking a lot, but would it be possible to add (or at least make it easy to add later) an OSSL function similar to osSetLinkPrimitiveParams() and osGetLinkPrimitiveParams() that supports getting and setting the normal (bump) map and the specular (shinyness) map and its variables. Or else even incorporate it into the existing functions. Often with mesh it can be a challenge to select a specific face, plus support for these functions would make it possible to texture via HUD or dynamically alter them as part of a script sequence.
(0025021)
dahlia (administrator)
2014-01-20 03:32

Applied. Thanks Oren!

Mata Hari: could you open a new Mantis with your suggestion for the OS scripting function?

- Issue History
Date Modified Username Field Change
2014-01-05 05:48 orenh New Issue
2014-01-05 05:48 orenh Status new => assigned
2014-01-05 05:48 orenh Assigned To => dahlia
2014-01-05 05:48 orenh File Added: 0001-Materials-support-the-viewer-removing-the-material-i.patch
2014-01-05 05:48 orenh File Added: 0002-Renamed-MaterialsDemoModule-to-MaterialsModule.patch
2014-01-05 05:48 orenh File Added: 0003-Materials-module-a-Store-materials-as-assets-b-Final.patch
2014-01-05 05:48 orenh File Added: 0004-When-asked-to-change-the-Material-for-one-face-chang.patch
2014-01-05 05:48 orenh File Added: 0005-Check-agent-permissions-before-modifying-an-object-s.patch
2014-01-05 05:52 orenh Status assigned => patch included
2014-01-06 13:55 dahlia Note Added: 0024945
2014-01-06 18:46 Mata Hari Note Added: 0024946
2014-01-20 03:32 dahlia Note Added: 0025021
2014-01-20 03:32 dahlia Status patch included => resolved
2014-01-20 03:32 dahlia Resolution open => fixed
2014-01-20 03:46 Mata Hari Relationship added related to 0006824
2014-01-20 03:48 Mata Hari Relationship added related to 0006832
2014-01-20 03:52 Mata Hari Relationship added related to 0006825
2014-07-29 13:42 chi11ken Status resolved => closed


Copyright © 2000 - 2012 MantisBT Group
Powered by Mantis Bugtracker